<!-- https://stackblitz.com/edit/web-platform-sdgbwq?file=index.html -->

<!DOCTYPE html>
<html>
  <head>
    <script src="https://unpkg.com/konva@8.0.4/konva.min.js"></script>
    <meta charset="utf-8" />
    <title>Konva Rect Demo</title>
    <style>
      body {
        margin: 0;
        padding: 0;
        overflow: hidden;
        background-color: #f0f0f0;
      }
    </style>
  </head>

  <body>
    <div id="container"></div>
    <script>
      var nodeCollection = {
        switch1: [
          { type: "", color: "#cf8c4d" },
          { type: "", color: "#cf8c4d" },
          { type: "", color: "#cf8c4d" },
          { type: "", color: "#cf8c4d" },
          { type: "", color: "#C96FAB" },
          { type: "", color: "#C96FAB" },
          { type: "", color: "#C96FAB" },
          { type: "", color: "#C96FAB" },
          { type: "", color: "#05D2DB" },
          { type: "", color: "#05D2DB" },
          { type: "", color: "#05D2DB" },
          { type: "", color: "#05D2DB" },
          { type: "", color: "#CCCC00" },
          { type: "", color: "#CCCC00" },
          { type: "", color: "#CCCC00" },
          { type: "", color: "#CCCC00" },
          { type: "", color: "#cf8c4d" },
          { type: "", color: "#cf8c4d" },
          { type: "", color: "#C96FAB" },
          { type: "", color: "#C96FAB" },
          { type: "", color: "#05D2DB" },
          { type: "", color: "#05D2DB" },
          { type: "", color: "#CCCC00" },
          { type: "", color: "#CCCC00" },
        ],
        switch2: [
          { type: "", color: "#cf8c4d" },
          { type: "", color: "#cf8c4d" },
          { type: "", color: "#C96FAB" },
          { type: "", color: "#C96FAB" },
          { type: "", color: "#05D2DB" },
          { type: "", color: "#05D2DB" },
          { type: "", color: "#CCCC00" },
          { type: "", color: "#CCCC00" },
          { type: "APA", color: "#6890f0" },
          { type: "APA", color: "#6890f0" },
          { type: "APA", color: "#6890f0" },
          { type: "APA", color: "#6890f0" },
          { type: "APA", color: "#b5a18c" },
          { type: "APA", color: "#b5a18c" },
          { type: "APA", color: "#b5a18c" },
          { type: "APA", color: "#b5a18c" },
          { type: "APA", color: "#fdb7a9" },
          { type: "APA", color: "#fdb7a9" },
          { type: "APA", color: "#fdb7a9" },
          { type: "APA", color: "#fdb7a9" },
          { type: "APA", color: "#48465b" },
          { type: "APA", color: "#48465b" },
          { type: "APA", color: "#48465b" },
          { type: "APA", color: "#48465b" },
        ],
      };

      var nodeToHostList = {};

      var nodeToNodeList = [
        { source: { switch: 1, port: 17 }, target: { switch: 2, port: 1 } },
        { source: { switch: 1, port: 18 }, target: { switch: 2, port: 2 } },
        { source: { switch: 1, port: 19 }, target: { switch: 2, port: 3 } },
        { source: { switch: 1, port: 20 }, target: { switch: 2, port: 4 } },
        { source: { switch: 1, port: 21 }, target: { switch: 2, port: 5 } },
        { source: { switch: 1, port: 22 }, target: { switch: 2, port: 6 } },
        { source: { switch: 1, port: 23 }, target: { switch: 2, port: 7 } },
        { source: { switch: 1, port: 24 }, target: { switch: 2, port: 8 } },
      ];

      var hostCollection = {
        switch1: [
          {
            data: {
              ip: "192.168.2.5",
              mac: "0e:24:45:78:98",
              id: 1,
              name: "",
              composed: false,
            },
            port: [1, 2, 3, 4],
          },
          {
            data: {
              ip: "192.168.2.6",
              mac: "0e:24:45:78:99",
              id: 2,
              name: "Node 2",
              composed: true,
            },
            port: [5, 6, 7, 8],
          },
          {
            data: {
              ip: "192.168.2.7",
              mac: "0e:24:45:78:96",
              id: 3,
              name: "Node 3",
              composed: true,
            },
            port: [9, 10, 11, 12],
          },
          {
            data: {
              ip: "192.168.2.8",
              mac: "0e:24:45:78:95",
              id: 4,
              name: "Node 4",
              composed: true,
            },
            port: [13, 14, 15, 16],
          },
        ],
        switch2: [
          {
            data: {
              ip: "192.168.3.5",
              mac: "1e:24:45:78:98",
              id: 5,
              name: "BoX1",
              apa: true,
            },
            port: [9, 10, 11, 12],
          },
          {
            data: {
              ip: "192.168.3.6",
              mac: "2e:24:45:78:99",
              id: 6,
              name: "BoX2",
              apa: true,
            },
            port: [13, 14, 15, 16],
          },
          {
            data: {
              ip: "192.168.3.7",
              mac: "3e:24:45:78:96",
              id: 7,
              name: "BoX3",
              apa: true,
            },
            port: [17, 18, 19, 20],
          },
          {
            data: {
              ip: "192.168.3.8",
              mac: "5e:24:45:78:95",
              id: 8,
              name: "BoX4",
              apa: true,
            },
            port: [21, 22, 23, 24],
          },
        ],
      };

      var backgroundColorMap = {
        "#C96FAB": "#e8dce6",
        "#05D2DB": "#caebed",
        "#CCCC00": "#e7e9c0",
      };

      var width = window.innerWidth;
      var height = window.innerHeight;

      var stage = new Konva.Stage({
        container: "container",
        width: width,
        height: height,
      });

      var layer = new Konva.Layer({
        x: width / 2 - 1077 / 2,
        y: height / 3,
      });

      var switchGroup = {};
      switchGroup["switch1"] = {};
      switchGroup["switch2"] = {};
      switchGroup["switch1"].hostList = [];
      switchGroup["switch1"].linkList = [];
      switchGroup["switch2"].hostList = [];
      switchGroup["switch2"].linkList = [];

      switchGroup["switch1"].group = new Konva.Group({
        x: 20,
        y: 20,
        width: 1077,
        height: 70,
      });
      switchGroup["switch1"].groupPosition =
        switchGroup["switch1"].group.absolutePosition();

      var rect1 = new Konva.Rect({
        width: 1077,
        height: 70,
        fill: "#48465B",
        stroke: "#48465B",
        strokeWidth: 2,
        cornerRadius: 5,
      });

      switchGroup["switch1"].group.add(rect1);

      function generateNameGroup(type) {
        var nameGroup = new Konva.Group({
          width: 125,
          height: 70,
        });
        switchGroup[type].nameGroup = nameGroup;
        switchGroup[type].nameGroupPosition = nameGroup.absolutePosition();

        var switchName = new Konva.Text({
          text: "M1\n\n10.2.0.1",
          fontSize: 13,
          fontFamily: "Calibri",
          fill: "#fff",
          width: 125,
          height: 70,
          x: 65,
          verticalAlign: "middle",
        });
        switchGroup[type].nameGroup.add(switchName);
        switchGroup[type].group.add(nameGroup);
      }

      function drawNode(type) {
        switchGroup[type].nodeList = [];

        var nodeGroup = new Konva.Group({
          width: 952,
          height: 70,
          x: 145,
        });

        switchGroup[type].nodeGroup = nodeGroup;
        switchGroup[type].nodeGroupPosition = nodeGroup.absolutePosition();
        function getCalculatePosition(currentIndex) {
          if (currentIndex > 0) {
            const previousPos = switchGroup[type].nodeList[currentIndex - 1];
            return previousPos.x + 30 + 5 + (currentIndex % 4 === 0 ? 15 : 0);
          }
          return 0;
        }
        nodeCollection[type].map((data, index) => {
          const id = index + 1;
          var smallRect = new Konva.Rect({
            width: 30,
            height: 30,
            x: getCalculatePosition(index),
            y: 17,
            id: type + "Port" + id,
            strokeWidth: 1.5,
            stroke: data.color,
            ...(data.type === "APA" ? { fill: "#fff" } : {}),
          });
          var smallRectText = new Konva.Text({
            width: 30,
            height: 30,
            fontSize: 13,
            fontFamily: "Calibri",
            verticalAlign: "middle",
            align: "center",
            x: getCalculatePosition(index),
            y: 17,
            fill: data.color,
            text: index + 1,
          });

          switchGroup[type].nodeList.push({
            ...smallRect.absolutePosition(),
            id: smallRect.id(),
          });
          nodeGroup.add(smallRect);
          nodeGroup.add(smallRectText);
        });
        switchGroup[type].group.add(nodeGroup);
      }

      drawNode("switch1");

      function generateAPA(APAStrokeColor = "#48465b") {
        return `<svg xmlns="http://www.w3.org/2000/svg" width="50" height="50" viewBox="0 0 57 52"><defs><style>.a,.b{fill:none;}.a{stroke:${APAStrokeColor};stroke-linecap:round;stroke-linejoin:round;stroke-width:5px;}</style></defs><g transform="translate(-23.791 -205.287)"><g transform="translate(26.291 210.287)"><line class="a" x1="22.97" transform="translate(28.5 18.001)"/><line class="a" x1="13.424" transform="translate(1.076 18.001)"/><path class="a" d="M10.97,7.886,2,21.6V41.4a5.2,5.2,0,0,0,5.2,5.2H48.8A5.2,5.2,0,0,0,54,41.4V21.6L45.03,7.886A5.2,5.2,0,0,0,40.376,5H15.624A5.2,5.2,0,0,0,10.97,7.886Z" transform="translate(-2 -5)"/><path class="a" d="M21.35,2,3,24.02H19.515L17.68,38.7l18.35-22.02H19.515Z" transform="translate(6.484 1.276)"/></g><rect class="b" width="50" height="50" transform="translate(26.291 205.287)"/></g></svg>`;
      }

      function systemImage() {
        const img = `<svg xmlns="http://www.w3.org/2000/svg" width="50" height="50" viewBox="0 0 57 52"><defs><style>.a,.c{fill:none;}.a{stroke:#33b0e0;stroke-width:2px;}.b,.e{fill:#fff;}.d,.f{fill:#48465b;}.f{font-size:13px;font-family:Poppins-Regular, Poppins;}.g,.h{stroke:none;}.h{fill:#48465b;}</style></defs><g transform="translate(39 25)"><g transform="translate(0 0)"><rect class="c" width="50" height="50" transform="translate(0 0.001)"/></g><g transform="translate(-671.203 -370.985)"><g transform="translate(671.703 375.135)"><g transform="translate(0 18.909)"><path class="d" d="M721.34,387.862H674.067a2.364,2.364,0,0,1,0-4.727H721.34a2.364,2.364,0,0,1,0,4.727Z" transform="translate(-671.703 -383.135)"/></g><path class="d" d="M716.612,417.68H678.794a7.1,7.1,0,0,1-7.091-7.091V396.408a2.348,2.348,0,0,1,.251-1.057l8.15-16.281a7.054,7.054,0,0,1,6.346-3.935h22.5a7.051,7.051,0,0,1,6.346,3.935l8.155,16.281a2.378,2.378,0,0,1,.248,1.057V410.59A7.1,7.1,0,0,1,716.612,417.68ZM676.43,396.968V410.59a2.365,2.365,0,0,0,2.364,2.364h37.818a2.365,2.365,0,0,0,2.364-2.364V396.968l-7.907-15.787a2.347,2.347,0,0,0-2.118-1.319h-22.5a2.35,2.35,0,0,0-2.116,1.312l0,.007Zm5.791-16.846h0Z" transform="translate(-671.703 -375.135)"/><g transform="translate(9.447 28.405)"><path class="d" d="M678.064,391.827a2.375,2.375,0,0,1-.9-.165,2.1,2.1,0,0,1-.756-.52,2.357,2.357,0,0,1-.709-1.654,2.471,2.471,0,0,1,.189-.922,2.068,2.068,0,0,1,.52-.756,2.444,2.444,0,0,1,3.333,0,2.863,2.863,0,0,1,.52.756,2.45,2.45,0,0,1,.165.922,2.339,2.339,0,0,1-.165.9,2.4,2.4,0,0,1-.52.756A2.339,2.339,0,0,1,678.064,391.827Z" transform="translate(-675.7 -387.152)"/></g><g transform="translate(18.902 28.37)"><path class="d" d="M682.064,391.847a2.38,2.38,0,0,1-1.678-.685,2.335,2.335,0,0,1-.5-.756,2.359,2.359,0,0,1-.189-.9,2.468,2.468,0,0,1,.189-.922,2.336,2.336,0,0,1,.5-.756,2.378,2.378,0,0,1,.78-.52,2.407,2.407,0,0,1,3.1,1.276,2.45,2.45,0,0,1,.165.922,2.341,2.341,0,0,1-2.364,2.34Z" transform="translate(-679.7 -387.138)"/></g></g></g></g></svg>`;
      }

      function generateNodetoHostList(host, type) {
        const { data, port } = host;
        port.map((portNo) => {
          nodeToHostList[type].push({ source: portNo, target: data.id });
        });
      }

      function getHostIPPosition(id, type, inverted) {
        const size = 100;
        const radius = 50;
        const currentHost = switchGroup[type].nodeGroup.findOne("#" + id);
        const { x, y } = currentHost.position();
        const xPos = x - size / 2;
        let yPos = y;
        if (!inverted) {
          yPos = yPos - radius - 20 - 6;
        } else {
          yPos = yPos + radius + 20 - 6; //extra six bcz of switch port 6px extra in bottom
        }
        return { xPos, yPos };
      }

      function getHostNamePosition(id, type, inverted) {
        const size = 100;
        const radius = 50;
        const currentHostIP = switchGroup[type].nodeGroup.findOne("#" + id);
        const { x, y } = currentHostIP.position();
        const xPos = x;
        let yPos = y;
        if (!inverted) {
          yPos = yPos - 20;
        } else {
          yPos = yPos + 20;
        }
        return { xPos, yPos };
      }

      function getHostfillColor(host, type) {
        let borderColor = "#adadad";
        let bgColor = "none";
        console.log(host, "host");
        const { composed = false, apa = false } = host.data;

        const portNumber = host.port[0];
        const portColor = nodeCollection[type][portNumber - 1].color;
        if (apa) {
          borderColor = "#48465b";
          bgColor = "#fff";
        } else if (composed) {
          borderColor = portColor;
          bgColor = backgroundColorMap[portColor];
        }
        return { borderColor, bgColor };
      }

      function drawCircle(start, end, groupPorts, type, host, inverted) {
        generateNodetoHostList(host, type);
        const { borderColor, bgColor } = getHostfillColor(host, type);
        console.log({ borderColor, bgColor });
        const radius = 50;
        const id = host.data.id;
        const hostData = host;
        const url =
          "data:image/svg+xml;base64," + window.btoa(generateAPA(borderColor));
        //const url =  'data:image/svg+xml;base64,' + window.btoa(systemImage());

        var hostCircle = new Konva.Circle({
          x: calclateHostPosition(start, end, groupPorts, type),
          y: !inverted ? -110 : 180,
          id: "host" + id,
          ...(bgColor !== "none" ? { fill: bgColor } : {}),
          radius,
          stroke: borderColor,
          strokeWidth: 4,
          ...(bgColor === "none" ? { dash: [10, 10] } : {}),
        });
        switchGroup[type].hostList.push({
          ...hostCircle.absolutePosition(),
          id: hostCircle.id(),
        });
        switchGroup[type].nodeGroup.add(hostCircle);

        Konva.Image.fromURL(url, (hostImage) => {
          switchGroup[type].nodeGroup.add(hostImage);
          hostImage.setAttrs({
            x: calclateHostPosition(start, end, groupPorts, type) - 50 / 2,
            y: (!inverted ? -110 : 180) - radius / 2,
          });
          hostImage.on("click", function () {
            console.log("image id", id, hostData);
          });
        });
        hostCircle.on("click", function () {
          console.log("id", id, hostData);
        });
        const { xPos: ipXPos, yPos: ipYPos } = getHostIPPosition(
          hostCircle.id(),
          type,
          inverted
        );
        var hostIp = new Konva.Text({
          id: type + "HostIp" + id,
          width: 100,
          x: ipXPos,
          y: ipYPos,
          fontSize: 13,
          fontFamily: "Calibri",
          verticalAlign: "middle",
          align: "center",
          fill: "#b5b5b5",
          text: host.data.ip,
        });
        switchGroup[type].nodeGroup.add(hostIp);
        const { xPos: nameXPos, yPos: nameYPos } = getHostNamePosition(
          hostIp.id(),
          type,
          inverted
        );

        var hostName = new Konva.Text({
          id: type + "HostName" + id,
          width: 100,
          x: nameXPos,
          y: nameYPos,
          fontSize: 14,
          fontFamily: "Calibri",
          verticalAlign: "middle",
          align: "center",
          fill: "#48465b",
          text: host.data.name,
        });
        switchGroup[type].nodeGroup.add(hostName);
      }

      function calclateHostPosition(start, end, groupOfPorts, type) {
        const sliceGroup = switchGroup[type].nodeList.slice(
          start,
          end,
          groupOfPorts
        );
        const xadd = sliceGroup.reduce((acc, curr) => {
          acc += curr.x;
          return acc;
        }, 0);
        return (xadd + groupOfPorts * 2) / 4 + 15; // group nuber of host + gap between ports
      }

      function drawHost(type, portGroup, inverted = false) {
        nodeToHostList[type] = [];
        hostCollection[type].map((host) => {
          const { data, port } = host;
          const noOfport = port.length;
          const startPort = port[0] - 1;
          const endPort = port[noOfport - 1];
          drawCircle(startPort, endPort, portGroup, type, host, inverted);
        });
      }

      drawHost("switch1", 4);

      function getConnectorPoints(from, to, inverted) {
        console.log(inverted, "inverted");
        const dx = to.x - 25 - from.x + 15; //25 radius of the circle, 15 center of the port,since 30 is size so 30/2
        const dy = to.y - 25 - from.y + 25 + (inverted ? 30 : 0); // 30 size of port box
        let angle = Math.atan2(-dy, dx);
        const radius = 50;

        return [
          // from.x + -radius * Math.cos(angle + Math.PI),
          //   from.y + radius * Math.sin(angle + Math.PI),
          from.x + 15,
          from.y + (inverted ? 30 : 0),
          to.x + -radius * Math.cos(angle),
          to.y + radius * Math.sin(angle),
        ];
      }

      function drawConnection(type, inverted = false) {
        const connectionList = nodeToHostList[type];
        connectionList.forEach((connect) => {
          const { source, target } = connect;
          const lineId = type + "Port" + source + "-host" + target;
          var fromNode = switchGroup[type].nodeGroup.findOne(
            "#" + type + "Port" + source
          );
          var toNode = switchGroup[type].nodeGroup.findOne("#host" + target);
          const points = getConnectorPoints(
            fromNode.position(),
            toNode.position(),
            inverted
          );
          var line = new Konva.Line({
            id: lineId,
            points: points,
            strokeWidth: 2,
            stroke: "#34b0e0",
          });
          switchGroup[type].nodeGroup.add(line);
        });
      }

      generateNameGroup("switch1");

      function drawSwitchToSwitchConnection() {
        nodeToNodeList.map(
          ({
            source: { switch: srcSwitch, port: srcPort },
            target: { switch: targetSwitch, port: targetPort },
          }) => {
            const id1 = "#switch" + srcSwitch + "Port" + srcPort;
            const id2 = "#switch" + targetSwitch + "Port" + targetPort;
            var fromNode = layer.findOne(id1);
            var toNode = layer.findOne(id2);
            const { x, y } = fromNode.getAbsolutePosition(layer);
            const { x: x1, y: y1 } = toNode.getAbsolutePosition(layer);
            const points = [x + 15, y + 30, x1 + 15, y1];
            var line = new Konva.Line({
              id: "switch1Port1-switch2Port1",
              points: points,
              strokeWidth: 2,
              stroke: "#34b0e0",
            });
            layer.add(line);
          }
        );
      }

      const absolutePosition = switchGroup["switch1"].groupPosition;

      switchGroup["switch2"].group = new Konva.Group({
        x: absolutePosition.x,
        y: absolutePosition.y + 96 + 70 + 2, // gap + switch height + strokeWidth
        width: 1077,
        height: 70,
      });
      switchGroup["switch2"].groupPosition =
        switchGroup["switch2"].group.absolutePosition();

      var rect2 = new Konva.Rect({
        width: 1077,
        height: 70,
        fill: "#48465B",
        stroke: "#48465B",
        strokeWidth: 2,
        cornerRadius: 5,
      });

      // console.log(switchGroup['switch2'].group.absolutePosition())

      // add the shape to the layer
      // layer.add(rect2);
      switchGroup["switch2"].group.add(rect2);
      generateNameGroup("switch2");
      drawNode("switch2");
      drawHost("switch2", 4, true);

      layer.add(switchGroup["switch1"].group);
      drawConnection("switch1");
      layer.add(switchGroup["switch2"].group);
      drawConnection("switch2", true);

      console.log(switchGroup, "switchGroup");

      drawSwitchToSwitchConnection();

      // add the layer to the stage

      stage.add(layer);
    </script>
  </body>
</html>
